/***************************************************************************\
*                                                                           *
* BuilderX Version 4.0                                                      *
*                                                                           *
* Copyright (C) 1999 Xironic. All Rights Reserved.                          *
*                                                                           *
\***************************************************************************/


//---------------------------------------------------------------------------
#ifndef BX3DLightH
#define BX3DLightH
//---------------------------------------------------------------------------
#include "BX3DFrame.h"

//---------------------------------------------------------------------------
enum TLightType{tDirectional,tPoint,tAmbient,tSpot,tParallelPoint};

//TBX3DLight
//---------------------------------------------------------------------------
class PACKAGE TBX3DLight : public TBX3DCustomFrame
{
  private:
    bool FVisible;
    void __fastcall SetVisible(bool);
    void __fastcall UpdateVisible(bool);
    void __fastcall Release();

    float FConstantAttenuation;
    float FLinearAttenuation;
    float FQuadraticAttenuation;
    void __fastcall SetConstantAttenuation(float);
    void __fastcall SetLinearAttenuation(float);
    void __fastcall SetQuadraticAttenuation(float);
    float __fastcall GetConstantAttenuation();
    float __fastcall GetLinearAttenuation();
    float __fastcall GetQuadraticAttenuation();

    TColor __fastcall GetColor();

    TLightType FType;
    void __fastcall SetType(TLightType);
    TLightType __fastcall GetType();
    void __fastcall ChangeType();

    float FSpotUmbraAngle;
    float FSpotPenumbraAngle;
    float FSpotRange;
    void __fastcall SetSpotUmbraAngle(float);
    void __fastcall SetSpotPenumbraAngle(float);
    void __fastcall SetSpotRange(float);
    float __fastcall GetSpotUmbraAngle();
    float __fastcall GetSpotPenumbraAngle();
    float __fastcall GetSpotRange();

    TBX3DFrame *FEnableFrame;
    void __fastcall SetEnableFrame(TBX3DFrame*);
    TBX3DFrame* __fastcall GetEnableFrame();

    void __fastcall Init();
    void __fastcall Create();
    void __fastcall Change();
    void __fastcall ChangeColor();
    void __fastcall ChangeParamLight();

    LPDIRECT3DRMLIGHT FIDirect3DLight;
    LPDIRECT3DRMLIGHT __fastcall GetIDirect3DLight();

  public:
    virtual void __fastcall Notification(TComponent* AComponent, TOperation Operation);
    void __fastcall Clone(TBX3DLight**);
    __fastcall TBX3DLight(TComponent* Owner);
    __fastcall ~TBX3DLight();

    __property LPDIRECT3DRMLIGHT IDirect3DLight={read=GetIDirect3DLight};
  __published:
    __property bool Visible={read=FVisible,write=SetVisible,default=true};
    __property TColor Color={read=GetColor,write=SetColor};
    __property TLightType Type={read=GetType,write=SetType};
    __property float SpotPenumbraAngle={read=GetSpotPenumbraAngle,write=SetSpotPenumbraAngle,default=30};
    __property float SpotUmbraAngle={read=GetSpotUmbraAngle,write=SetSpotUmbraAngle,default=25};
    __property float SpotRange={read=GetSpotRange,write=SetSpotRange,default=256};
    __property float AConstantAttenuation={read=GetConstantAttenuation,write=SetConstantAttenuation,default=1};
    __property float ALinearAttenuation={read=GetLinearAttenuation,write=SetLinearAttenuation};
    __property float AQuadraticAttenuation={read=GetQuadraticAttenuation,write=SetQuadraticAttenuation};
    __property TBX3DFrame* EnableFrame={read=GetEnableFrame,write=SetEnableFrame};
    __property ParentFrame;
    __property Position;
    __property Rotation;
    __property Orientation;
    __property Velocity;
};
//---------------------------------------------------------------------------
#endif

