/***************************************************************************\
*                                                                           *
* BuilderX Version 4.0                                                      *
*                                                                           *
* Copyright (C) 1999 Xironic. All Rights Reserved.                          *
*                                                                           *
\***************************************************************************/


//---------------------------------------------------------------------------
#ifndef BXIKeyboardH
#define BXIKeyboardH

//---------------------------------------------------------------------------
#include "dinput.h"

#include "BX3DFrame.h"

typedef void __fastcall (__closure *TEventKey)(System::TObject* Sender,DWORD Key,DWORD TimeStamp,DWORD Sequence);
typedef void __fastcall (__closure *TEventKeyPressed)(System::TObject* Sender,DWORD Key);
#define MAX_BUFFER_SIZE 256
class TKeyCheckLoop;

class PACKAGE TBXIKeyboard : public TComponent
{
  private:
    DWORD Elements;
    DWORD PrevElements;    
    DIDEVICEOBJECTDATA prevdidod[MAX_BUFFER_SIZE];
    DIDEVICEOBJECTDATA didod[MAX_BUFFER_SIZE];

    DWORD FBufferSize;
    void __fastcall SetBufferSize(DWORD Value);
    bool FBuffered;
    void __fastcall SetBuffered(bool Value);
    bool FBackground;
    void __fastcall SetBackground(bool Value);
    bool FExclusive;
    void __fastcall SetExclusive(bool Value);

    TKeyCheckLoop *KeyCheckLoop;
    BYTE prevbuffer[256];
    void __fastcall SetFocusControl();
    void __fastcall Tick(TObject*);
    TEventKeyPressed FOnKeyPressed;
    TNotifyEvent FOnMoreKeys;
    TEventKey FOnKeyDown;
    TEventKey FOnKeyUp;
    void __fastcall Activation();
    void __fastcall Deactivation();

    bool FAutoCheck;
    void __fastcall SetAutoCheck(bool);
    bool FActive;
    void __fastcall SetActive(bool);
    void __fastcall GenEvent();

  protected:
  public:

    DIOBJECTDATAFORMAT of;
    BYTE Keys[256];
    void __fastcall CallCheckChange();
    bool CheckChange();
    bool IsKeyPressed(BYTE);
    LPDIRECTINPUT  DIHandle;
    LPDIRECTINPUTDEVICE  DIDevice2;

    __fastcall TBXIKeyboard(TComponent* Owner);
    __fastcall ~TBXIKeyboard();

    __property bool AutoCheck={read=FAutoCheck,write=SetAutoCheck};
    __property bool Active={read=FActive,write=SetActive};
  __published:
    __property DWORD BufferSize={read=FBufferSize,write=SetBufferSize,default=16};
    __property bool Buffered={read=FBuffered,write=SetBuffered,default=true};
    __property bool Exclusive={read=FExclusive,write=SetExclusive,default=true};
    __property bool Background={read=FBackground,write=SetBackground};
    __property TEventKeyPressed OnKeyPressed={read=FOnKeyPressed,write=FOnKeyPressed};
    __property TEventKey OnKeyUp={read=FOnKeyUp,write=FOnKeyUp};
    __property TEventKey OnKeyDown={read=FOnKeyDown,write=FOnKeyDown};
    __property TNotifyEvent OnMoreKeys={read=FOnMoreKeys,write=FOnMoreKeys};
};

class TKeyCheckLoop: public TThread
{
  private:
    TBXIKeyboard *ptKeyboard;
    void __fastcall UpdateView();
    void __fastcall Stop();

  protected:
    virtual void __fastcall Execute(void);
  public:
    bool Term;
    void __fastcall UpdateParam();
    __fastcall TKeyCheckLoop(TBXIKeyboard *);
    __fastcall ~TKeyCheckLoop();
};

#endif


